-module(supervisor_process).	
-compile(export_all).

start(T) ->
    Pid = spawn_link(fun loop/0),
	register(T, Pid),				
						%%Usually, only registerd process can be used to supervise other processes.
	{ok, Pid}.			

rpc(Pid, Request) ->
    Pid ! {self(), Request},
    receive
        {Pid, Response} ->
           Response
    end.

loop() ->
    receive
		{exit, Reason} ->
			exit(Reason);
		{From, {ok, _Pid}} ->			
			From ! {self(), {ok}},
			loop();
		{From, Other} ->
			From ! {self(), {error, Other}},
			loop()	
	end.
	
init(RestartStrategy) ->
	{ok, {{RestartStrategy, 30000, 10000},[]}}.
	